using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using ScenarioFramework.Modules.FormHelper;
using System.Configuration;
using System.Xml;
using ScenarioFramework.Modules.DM.Application;
using ScenarioFramework.Modules.DM.DataBase;
using ScenarioFramework.Portal;

namespace ACEMPortal.ACEM.Infopath
{
	/// <summary>
	/// Summary description for Publish.
	/// </summary>
	public partial class Publish : System.Web.UI.Page
	{
		private const String TXTTEMP="temp.txt";
		private const String XMLTEMP="temp.xml";
		private const String BEGIN="<?xml";
		private const string idFNI="FNI";// nome dell'attributo di processo dove  memorizzato l'id del documento FNI
		private const string idRNI="RNI";// nome dell'attributo di processo dove  memorizzato l'id del documento RNI
		private const string idCCM="CCM";// nome dell'attributo di processo dove  memorizzato l'id del documento CCM
		private const string VIS_ATTRIBUTE="Visualizzazione";// nome dell'attributo di processo dove  memorizzata la visualizzazione dell FNI
		private const string FORNITURA="Forntitura";
		private const string RIESAME="Riesame";
		public DocumentManagerHelper dmHelper= new DocumentManagerHelper();

		protected void Page_Load(object sender, System.EventArgs e)
		{
			//Retrieving InfoPath Module Data and save on temp directory
			//TODO: Assign an univoque id to file
			string sFilePath = Server.MapPath ("\\ACEMPortal" ) ;
			string sFileName=sFilePath + "\\downloads\\" + TXTTEMP  + System.DateTime.Now.ToShortTimeString();
			Request.SaveAs(sFileName,false);

			/*
			StreamWriter temp= new StreamWriter(sPath+XMLTEMP,true);
			
			 //Copia sul file della sola parte dati di HTTPREQUEST
			using (StreamReader sr = new StreamReader(sPath+TXTTEMP))
			{
				String sline;
				bool bCopy=false;
				while ((sline = sr.ReadLine()) != null) 
				{
					//Si comincia a copiare da <?xml
					if (String.Compare(line,0,BEGIN,0,BEGIN.Length)==0) 
					{
						bCopy = true;
						temp.WriteLine(line);
					}
					else if ( bCopy )
					{
						temp.WriteLine(line);
					}  
				}
				
				temp.Close();
				sr.Close();
			}
			*/
			XmlDocument doc= new XmlDocument();
			doc.Load(sFileName);

			XmlNode xmlDocumentName = doc.SelectSingleNode("*");
			string sDocumentName = xmlDocumentName.Name; 
			string sIdActivity = string.Empty;

			XmlNode xmlNodeActivity = doc.SelectSingleNode ("*/idActivity");
			if ( xmlNodeActivity  != null ) 
			{
				sIdActivity = xmlNodeActivity.InnerText;
			}

			XmlNode Node= doc.SelectSingleNode("*/IdDocumento");
			string sIdDocument = Node.InnerText;
			XmlNode IdUser= doc.SelectSingleNode("*/User");
			string sUser = IdUser.InnerText;
			/*
			XmlNode IdAct= doc.SelectSingleNode("OrdineProduzione/IdActivity"); 
			IdAct.InnerText=IdActivity;
			*/
			XmlNode Idproc= doc.SelectSingleNode("*/idProcess"); 
			string sIdProcess = Idproc.InnerText;
			//doc.Save(sFilePath + sFileName);
			//

			//Retrieving DocumentId from xmlData.
			//string sDocId=formHelper.GetAttribute("IdDocument",FormHelper.ACTION_PROCESSATTRIBUTES);
				
			DocumentManagerDBHelper dmDBHelper = null;
			dmDBHelper = new DocumentManagerDBHelper();
			DocumentHelper docHelper=new DocumentHelper (dmDBHelper);

			string sIdFile=docHelper.GetInstanceFileName(sIdDocument,"1",sDocumentName,"xml");


			System.IO.File.Copy(sFileName,sIdFile,true);
			System.IO.File.Delete(sFileName);
			
			/*
			string sout=string.Empty;
			string sIdSlave=string.Empty;
			string sDocVer=string.Empty;
			
			string sVis= formHelper.GetAttribute(VIS_ATTRIBUTE,FormHelper.ACTION_PROCESSATTRIBUTES);
			if (sVis == FORNITURA)
			{
				formHelper.OnAction("Complete.FNI.Fornitura","","",sout,"user");
				//gestione item fornitura
			
				dmHelper.CreateDocument("",idRNI,out sIdSlave,out sDocVer);
				formHelper.OnAction("Create.RNI","","",sout,"user");
		

				dmHelper.CreateDocument("",idCCM,out sIdSlave,out sDocVer);
				formHelper.OnAction("Create.CCM","","",sout,"user");
				formHelper.SetAttribute(VIS_ATTRIBUTE,RIESAME,FormHelper.ACTION_PROCESSATTRIBUTES);	
			}
			else 
			{
				formHelper.OnAction("Complete.FNI.Riesame","","",sout,"user");
				//gestione item riesame
			}
			*/
			FormHelper formHelper = null;
			formHelper = Global.FormsHelper.GetFormHelper();
			formHelper.LoadXmlAttributes(sIdProcess,"",FormHelper.ACTION_PROCESSATTRIBUTES);
			string sUrl = string.Empty;
			
			if ( sIdActivity.CompareTo ( string.Empty ) == 0 )
			{
				sIdActivity=sDocumentName;
			}
		
			string sMessage = formHelper.OnAction("Complete."+sIdActivity,sIdProcess, sIdActivity, "",  sUser, ref sUrl, false);

			string sParameters = "?Message="+sMessage;
			sParameters+="&DocumentName=" + sDocumentName;
			sParameters+="&IdDocument=" + sIdDocument;
			sParameters+="&IdProcess=" + sIdProcess;
			sParameters+="&User=" + sUser;
			sParameters+="&ActivityName=" + sIdActivity;

			Response.Redirect ( sUrl +  sParameters);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
		}
		#endregion
	}
}
