using System;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Configuration;
using ScenarioFramework.Modules.DM.DataBase;
using ScenarioFramework.Modules.DM.DataModel;
using ScenarioFramework.Modules.DM.Application;

namespace ACEMPortal.UserControls
{
	/// <summary>
	///		Descrizione di riepilogo per DocumentAttaches.
	/// </summary>
	public partial class DocumentAttaches : System.Web.UI.UserControl
	{
		public bool AttachOnlyFromGrid = false;


		public string sIdDocument = string.Empty;
		public string DocumentType = string.Empty;

		protected DocumentManagerDBHelper dmDBHelper = null;

		XMLDocumentInstance document = null;
		private string sDocumentVersion=string.Empty;

		protected void Page_Load(object sender, System.EventArgs e)
		{
			sDocumentVersion=(string)Session["DocumentVersion"];
			document = (XMLDocumentInstance) Session["DocumentInstance"];
            if (document == null)
                return;
			if ( Page.IsPostBack )
			{
			}
			else
			{
				this.RetrieveAttaches();
			}
		}

		#region Codice generato da Progettazione Web Form
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: questa chiamata  richiesta da Progettazione Web Form ASP.NET.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Metodo necessario per il supporto della finestra di progettazione. Non modificare
		/// il contenuto del metodo con l'editor di codice.
		/// </summary>
		private void InitializeComponent()
		{
			this.GridAttaches.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.GridAttaches_DeleteCommand);

		}
		#endregion

		private void GridAttaches_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			string sFileName = e.Item.Cells[0].Text;

			try
			{
				DocumentManagerHelper DocHelper = new DocumentManagerHelper();
				DocHelper.RemoveAttach (document.Id, DocumentType, sFileName);
			}
			catch (ScenarioFramework.Modules.DM.Application.Exception.DocumentManagerException er)
			{
				// redirect su pagina di errore per non aver potuto effettuare il download
				Response.Redirect("../CommandResult.aspx?RltMsg=" + er.Message + " File " + e.Item.Cells[0].Text);
			}

			this.RetrieveAttaches();
		}

		
		private void RetrieveAttaches()
		{
			try
			{
				XMLDocumentAttachFiles xmlAttaches = document.XMLDocumentVersions.Get(this.sDocumentVersion).XMLDocumentAttachFiles;
				
				DataTable dt = new DataTable();
				dt.Columns.Add(new DataColumn("Name", typeof(string)));
				dt.Columns.Add(new DataColumn("Description", typeof(string)));
				dt.Columns.Add(new DataColumn("Status", typeof(string)));
				dt.Columns.Add(new DataColumn("Export", typeof(string)));
				dt.Columns.Add(new DataColumn("Download", typeof(string)));
			
				DataRow dr = null;
				XMLDocumentFile xmlFile = null;
				dmDBHelper = new DocumentManagerDBHelper();
				DocumentHelper docHelper=new DocumentHelper (dmDBHelper);

				for (int i=0; i< xmlAttaches.Count;++i)
				{
					xmlFile = (XMLDocumentFile)xmlAttaches[i];			
					dr = dt.NewRow();
 
					dr[0] = xmlFile.Name;
					dr[1] = xmlFile.Description;
					dr[2] = xmlFile.Status;
					dr[3] = xmlFile.MigratePolicy;

					string sIdFile = string.Empty;
					string sFileName = string.Empty;
					switch ( xmlFile.Type)
					{
						case XMLDocumentBase.MAIN_NODE:
							XMLDocumentInstance documentAttach = dmDBHelper.GetDocumentInstance( xmlFile.Id );

							bool bRet = ScenarioFramework.WAPI.Role.CheckGrant( documentAttach.XMLGrants, Page.User.Identity.Name, "VISIBLE");
							if ( bRet )
							{
								string sASPXPage = "DocumentViewer.aspx";

								XMLDocuments xmlDocuments = documentAttach.XMLDocumentVersions.GetLastVersion().XMLDocuments;
								if ( xmlDocuments.Count == 0 )
								{
									sASPXPage = "DocumentDetails.aspx";
								}
								string sNodeName = documentAttach.Name.Replace (" ", "_");
								string html = "<a href='" + sASPXPage + "?DocumentId=" + xmlFile.Id + "&sm=DocumentationRepository" + "" + "&treenode=" + sNodeName + "'><img height='15' width='15' src='/SFPortal/images/file.gif'></a>";
								dr[4] = html;

							}

							break;

						default:
							sIdFile = docHelper.GetInstanceFileName(document.Id , this.sDocumentVersion, xmlFile.Id, xmlFile.Type);
							sFileName = docHelper.GetInstanceFileNameWithoutPath(document.Id , this.sDocumentVersion, xmlFile.Id, xmlFile.Type);

							//
							System.IO.File.Copy(sIdFile, ConfigurationSettings.AppSettings["DownloadDirectory"] + sFileName , true);
							dr[4] = "<a href='\\SFPortal\\downloads\\" +    sFileName + "' target='_new'><img height='15' width='15' src='/SFPortal/images/icon-floppy.gif'></a>";

							break;
					}


					
 
					dt.Rows.Add(dr);
				}
 
				GridAttaches.DataSource = new DataView(dt);
				GridAttaches.DataBind();
			}
			catch
			{
				// redirect su pagina di errore Parametri di Activity non presenti
				Response.Redirect( SFPortal.Redirect.GoError("NON E' POSSIBILE LEGGERE I DATI XML"));
			}
		}
	}
}
