/// <summary>
/// Scenario Framework WAPI Activities
/// </summary>
/// <author>Maurizio Farina (maurizio.farina@gmail.com)</author>
using System;
using System.Runtime.InteropServices;
using ScenarioFramework.WorkflowEngine.DataModel.WorkflowProcesses;
using ScenarioFramework.WorkflowEngine.DataModel.WorkflowRelevantData;

namespace ScenarioFramework.WAPI
{
	/// <summary>
	/// WAPIActivity.
	/// </summary>
	public partial class Activity
	{
		private Activity()
		{
        }

        /// <summary>
        /// Sets the activity attributes.
        /// </summary>
        /// <param name="xmlActivity">The XML activity.</param>
        /// <param name="xmlAttributes">The XML attributes.</param>
        /// <param name="sUser">The s user.</param>
        /// <param name="response">The response.</param>
        /// <returns></returns>
        public static String SetAttributes(long lProcessId, String sActivityName, XMLAttributes xmlAttributes, string sUser)
        {
            Response wapiResponse = new Response();
            XMLActivity xmlActivity = new XMLActivity();
            xmlActivity.ProcessId = 0;
            xmlActivity.Name = "";

            String sResult = Activity.SetActivityAttributes(xmlActivity.GetXML(false, 0), xmlAttributes.GetXML(false,0), sUser, ref wapiResponse);

            return sResult;
        }
    }
}
