using System;
using System.Runtime.InteropServices;

namespace ScenarioFramework.WAPI
{
	/// <summary>
	/// Descrizione di riepilogo per wrpWAPIRequest.
	/// </summary>
	public class Workflow
	{
		/// <summary>
		/// Initializes a new instance  of the <see cref="Workflow"/> class.
		/// </summary>
		public Workflow()
		{
		}

		/// <summary>
		/// Gets the workflow list.
		/// </summary>
		/// <param name="response">The response.</param>
		/// <returns></returns>
		[ DllImport( "WAPI.dll", EntryPoint="getWorkflowList")]
		private static extern String GetWorkflowList( ref Response response );

		/// <summary>
		/// Gets the workflow running list.
		/// </summary>
		/// <param name="response">The response.</param>
		/// <returns></returns>
		[ DllImport( "WAPI.dll", EntryPoint="getWorkflowRunningList")]
		private static extern String GetWorkflowRunningList( ref Response response );

		/// <summary>
		/// Adds the workflow.
		/// </summary>
		/// <param name="sXMLWorkflow">The s XML workflow.</param>
		/// <param name="response">The response.</param>
		/// <returns></returns>
		[ DllImport( "WAPI.dll", EntryPoint="addWorkflow")]
		private static extern String AddWorkflow( string sXMLWorkflow, ref Response response );

	}
}
