using System;
using ScenarioFramework.WorkflowEngine.DataModel;

namespace ScenarioFramework.WorkflowEngine.DataModel.Common
{
	//*********************************************************************
	//
	// Grant Class
	//
	// toto : inserire l'esatta descrizione di ci che fa l'oggetto
	//
	//*********************************************************************
	public class XMLGrant : bOSdotNET.XML.Data.XMLObject 
	{
		public const string MAIN_NODE			= "Grant";

		private const string ENABLED_ATTRIBUTE	= "Enabled";
		private const string TYPE_ATTRIBUTE		= "Type";

		public const string YES_ENABLED			= "YES";
		public const string NO_ENABLED			= "NO";

		public const string EXECUTION_TYPE		= "EXECUTION";
		public const string VISIBLE_TYPE		= "VISIBLE";

		/** FIELDS **/

		private string sEnabled;
		private string sType;

		private WorkflowParticipantsData.XMLUsers vUsers;
		private WorkflowParticipantsData.XMLRoles vRoles;

		/** CONSTRUCTORS **/

		/** CONSTRUCTOR Width simple Property **/
		public XMLGrant()
		{
			this.Init();
		}

		/** CONSTRUCTOR Width xml parsering**/
		public XMLGrant(System.Xml.XmlNode node)
		{
			this.Parse(node);
		}

		/** PROPERTIES **/


		public string Enabled 
		{
			get { return sEnabled; }
			set { sEnabled = value; }
		}

		public string Type 
		{
			get { return sType; }
			set { sType = value; }
		}

		public WorkflowParticipantsData.XMLRoles XMLRoles 
		{
			get { return vRoles; }
			set { vRoles = value; }
		}

		public  WorkflowParticipantsData.XMLUsers XMLUsers 
		{
			get { return vUsers; }
			set { vUsers = value; }
		}

		override public void Init()
		{
			sEnabled= string.Empty;
			sType= string.Empty;

			vUsers = new ScenarioFramework.WorkflowEngine.DataModel.WorkflowParticipantsData.XMLUsers();
			vRoles = new ScenarioFramework.WorkflowEngine.DataModel.WorkflowParticipantsData.XMLRoles();
		}

		/** Parsering method to fill the object **/
		override public void Parse(System.Xml.XmlNode node2Parse)
		{
			this.Init();

			System.Xml.XmlNode node;

			/** find the attributes situated on the root tag **/
			for ( int i=0; i<node2Parse.Attributes.Count;i++)
			{
				node = node2Parse.Attributes.Item(i);
				switch ( node.Name ) 
				{
					case XMLGrant.ENABLED_ATTRIBUTE:
						sEnabled = node.InnerText;
						break;
					case XMLGrant.TYPE_ATTRIBUTE:
						sType = node.InnerText;
						break;
				}
			}

			/** find the attributes situated on sub tags **/
			for ( int i=0; i<node2Parse.ChildNodes.Count; i++)
			{
				node = node2Parse.ChildNodes[i];

				switch ( node.Name )
				{
					case ScenarioFramework.WorkflowEngine.DataModel.WorkflowParticipantsData.XMLUsers.MAIN_NODE:
						vUsers.Parse(node);
						break;
					case ScenarioFramework.WorkflowEngine.DataModel.WorkflowParticipantsData.XMLRoles.MAIN_NODE:
						vRoles.Parse(node);
						break;
				}
			}
		}

		/**Method to retive a node from object **/
		override public bOSdotNET.XML.XMLNode GetXMLNode()
		{
			bOSdotNET.XML.XMLNode xmlNode = new bOSdotNET.XML.XMLNode(XMLGrant.MAIN_NODE);
			xmlNode.AddAttribute ( new bOSdotNET.XML.XMLAttribute ( XMLGrant.ENABLED_ATTRIBUTE, sEnabled) );
			xmlNode.AddAttribute ( new bOSdotNET.XML.XMLAttribute ( XMLGrant.TYPE_ATTRIBUTE, sType) );

			xmlNode.AddNode ( vUsers.GetXMLNode() );
			xmlNode.AddNode ( vRoles.GetXMLNode() );
			
			return xmlNode;
		}
	}
}