using System;
using ScenarioFramework.WorkflowEngine.DataModel;

namespace ScenarioFramework.WorkflowEngine.DataModel.WorkflowApplicationsData
{
	//*********************************************************************
	//
	// ApplicationFunction Class
	//
	// toto : inserire l'esatta descrizione di ci che fa l'oggetto
	//
	//*********************************************************************
	public class XMLApplicationFunction : bOSdotNET.XML.Data.XMLObject 
	{
		public const string MAIN_NODE			= "Function";

		private const string NAME_ATTRIBUTE		= "Name";
		private const string TYPE_ATTRIBUTE		= "Type";
		private const string APPLICATION_NODE	= "Application";

		private const string SCRIPT_TYPE		= "SCRIPT";

		/** FIELDS **/

		private string sName;
		private string sApplication;
		private string sType;

		private Common.XMLFormalParameters vParameters;
		private XMLApplicationFunctionResult result;

		/** CONSTRUCTORS **/

		/** CONSTRUCTOR Width simple Property **/
		public XMLApplicationFunction()
		{
			this.Init();
		}
		
		/** CONSTRUCTOR Width Name Value **/
		public XMLApplicationFunction(string sFunctionName)
		{
			this.Init();

			this.Name = sFunctionName;
		}

		/** CONSTRUCTOR Width xml parsering**/
		public XMLApplicationFunction(System.Xml.XmlNode node)
		{
			this.Parse(node);
		}

		/** PROPERTIES **/


		public string Name 
		{
			get { return sName; }
			set { sName = value; }
		}

		public string Type
		{
			get { return sType; }
			set { sType = value; }
		}

		public string Application 
		{
			get { return sApplication; }
			set { sApplication = value; }
		}

		public Common.XMLFormalParameters XMLFormalParameters 
		{
			get { return vParameters; }
			set { vParameters = value; }
		}

		public XMLApplicationFunctionResult XMLApplicationFunctionResult 
		{
			get { return result; }
			set { result = value; }
		}

		/** INSTANCE METHODS **/

		override public void Init()
		{
			sName= string.Empty;
			sApplication= string.Empty;
			sType = string.Empty;

			vParameters = new Common.XMLFormalParameters();
			result = new XMLApplicationFunctionResult();
		}

		/** Parsering method to fill the object **/
		override public void Parse(System.Xml.XmlNode node2Parse)
		{
			this.Init();

			System.Xml.XmlNode node;

			/** find the attributes situated on the root tag **/
			for ( int i=0; i<node2Parse.Attributes.Count; i++)
			{
				node= node2Parse.Attributes.Item(i);

				switch (node.Name)
				{
					case XMLApplicationFunction.NAME_ATTRIBUTE:
						sName = node.InnerText;
						break;

					case XMLApplicationFunction.TYPE_ATTRIBUTE:
						sType = node.InnerText;
						break;
				}
			}

			/** find the attributes situated on sub tags **/
			for ( int i=0; i<node2Parse.ChildNodes.Count; i++)
			{
				node = node2Parse.ChildNodes[i];

				switch ( node.Name) 
				{
					case XMLApplicationFunction.APPLICATION_NODE:
						sApplication = node.InnerText;
						break;

					case Common.XMLFormalParameters.MAIN_NODE:
						vParameters.Parse(node);
						break;

					case XMLApplicationFunctionResult.MAIN_NODE:
						result.Parse(node);
						break;
				}
			}
		}

		/**Method to retive a node from object **/
		override public bOSdotNET.XML.XMLNode GetXMLNode()
		{
			bOSdotNET.XML.XMLNode xmlNode = new bOSdotNET.XML.XMLNode(XMLApplicationFunction.MAIN_NODE);
			xmlNode.AddAttribute ( new bOSdotNET.XML.XMLAttribute ( XMLApplicationFunction.NAME_ATTRIBUTE, sName) );
			xmlNode.AddAttribute ( new bOSdotNET.XML.XMLAttribute ( XMLApplicationFunction.TYPE_ATTRIBUTE, sType) );

			xmlNode.AddNode ( new bOSdotNET.XML.XMLNode (XMLApplicationFunction.APPLICATION_NODE, sApplication) );

			xmlNode.AddNode ( vParameters.GetXMLNode() );
			xmlNode.AddNode ( result.GetXMLNode() );
			
			return xmlNode;
		}
	}
}