using System;
using System.Collections;
using ScenarioFramework.WorkflowEngine.DataModel;

namespace ScenarioFramework.WorkflowEngine.DataModel.WorkflowApplicationsData
{
	//*********************************************************************
	//
	// XMLApplicationFunctions Class
	//
	// The XMLApplicationFunctions class represents a collection base of XMLApplicationFunction
	// Its imports methods from WAPI.XmlObjectSet like get set and add
	// XMLApplicationFunctions Has no fields
	//
	//*********************************************************************

	public class XMLApplicationFunctions : bOSdotNET.XML.Data.XMLObjectSet 
	{
		public const string MAIN_NODE	= "Functions";

		/** FIELDS **/

		/** no fields **/

		/** CONSTRUCTORS **/

		/** CONSTRUCTOR Empty **/
		public XMLApplicationFunctions()
		{
			this.Init();
		}

		/** CONSTRUCTOR Width xml parsering**/
		public XMLApplicationFunctions(System.Xml.XmlNode nodeList)
		{
			this.Parse(nodeList);
		}

		/** INSTANCE METHODS **/

		public override void Init()
		{
			this.RemoveAll();
		}	

		/**Method to parse an xml string into a nodelist collection **/

		override public void Parse(System.Xml.XmlNode nodeList)
		{
			this.Init();

			System.Xml.XmlNode node;

			for ( int i=0; i<nodeList.ChildNodes.Count;i++)
			{
				node = nodeList.ChildNodes[i];

				switch ( node.Name) 
				{
					case XMLApplicationFunction.MAIN_NODE:
						this.Add ( new XMLApplicationFunction(node));
						break;
				}
			}
		}

		/** Method for return a function from collection **/
		public XMLApplicationFunction Get(string sName)
		{
			XMLApplicationFunction function;

			for ( int i=0; i<this.List.Count; i++)
			{
				function = (XMLApplicationFunction)this.List[i];
				if ( function.Name == sName )
				{
					return function;
				}
			}

			throw new Exception.ApplicationFunctionNotFound(sName);
		}


		/** Method for return a function from collection **/
		public void RemoveByName(string sName)
		{
			XMLApplicationFunction function;

			for ( int i=0; i<this.List.Count; i++)
			{
				function = (XMLApplicationFunction)this.List[i];
				if ( function.Name == sName )
				{
					this.RemoveAt (i);
					return;
				}
			}

			throw new Exception.ApplicationFunctionNotFound(sName);
		}

		/**Method to retive a nodelist from collection **/
		override public bOSdotNET.XML.XMLNode GetXMLNode()
		{
			bOSdotNET.XML.XMLNode xmlNode = new bOSdotNET.XML.XMLNode(XMLApplicationFunctions.MAIN_NODE);

			for ( int i=0; i<this.Count;i++)
			{
				xmlNode.AddNode ( this[i].GetXMLNode() );
			}

			return xmlNode;
		}

		/** SORTING  FIELDS **/

		public enum SortFields 
		{
			Name,
			Application
		}

		/** SORTING METHODS **/


		public void Sort(SortFields sortField, bool isAscending) 
		{
			switch (sortField) 
			{
				case SortFields.Name:
					InnerList.Sort(new NameComparer());
					break;
				case SortFields.Application:
					InnerList.Sort(new ApplicationComparer());
					break;
				
			}
			if (!isAscending) InnerList.Reverse();
		}


		private sealed class NameComparer : IComparer 
		{
			public int Compare(object x, object y) 
			{
				XMLApplicationFunction first = (XMLApplicationFunction) x;
				XMLApplicationFunction second = (XMLApplicationFunction) y;
				return first.Name.CompareTo(second.Name);
			}
		}

		private sealed class ApplicationComparer : IComparer 
		{
			public int Compare(object x, object y) 
			{
				XMLApplicationFunction first = (XMLApplicationFunction) x;
				XMLApplicationFunction second = (XMLApplicationFunction) y;
				return first.Application.CompareTo(second.Application);
			}
		}

		
	}
}