using System;
using ScenarioFramework.WorkflowEngine.DataModel;

namespace ScenarioFramework.WorkflowEngine.DataModel.WorkflowProcesses
{	
	public class XMLBehaviourFinish : bOSdotNET.XML.Data.XMLObject
	{
		public const string MAIN_NODE				= "Finish";

		private const string MODE_ATTRIBUTE			= "Mode";

		private const string REPORT_NODE			= "Report";

		public const string AUTOMATIC_MODE			= "AUTOMATIC";
		public const string MANUAL_MODE			= "MANUAL";

		private string sMode;
		private string sReport;

		/** CONSTRUCTORS **/

		/** CONSTRUCTOR Width simple Property **/
		public XMLBehaviourFinish()
		{
			this.Init();
		}

		/** CONSTRUCTOR Width xml parsering**/
		public XMLBehaviourFinish(System.Xml.XmlNode node)
		{
			this.Parse(node);
		}

		/** PROPERTIES **/

		public string Mode 
		{
			get { return sMode; }
			set { sMode = value; }
		}

		public string Report 
		{
			get { return sReport; }
			set { sReport = value; }
		}

		/** INSTANCE METHODS **/

		override public void Init()
		{
			sMode = string.Empty;
			sReport = string.Empty;
		}

		override public void Parse(System.Xml.XmlNode node2Parse)
		{
			this.Init();

			System.Xml.XmlNode node;

			
			/** find the attributes situated on the root tag **/
			for ( int i=0; i<node2Parse.Attributes.Count;i++)
			{
				node = node2Parse.Attributes.Item(i);

				switch ( node.Name )
				{
					case XMLBehaviourFinish.MODE_ATTRIBUTE:
						sMode = node.InnerText;
						break;
				}
			}

			/** find the sub tags witch contains values **/
			for ( int i=0; i<node2Parse.ChildNodes.Count; i++)
			{
				node = node2Parse.ChildNodes[i];

				switch ( node.Name )
				{
					case XMLBehaviourFinish.REPORT_NODE:
						sReport= node.InnerText;
						break;
				}
			}
		}

		override public bOSdotNET.XML.XMLNode GetXMLNode()
		{
			bOSdotNET.XML.XMLNode xmlNode = new bOSdotNET.XML.XMLNode(XMLBehaviourFinish.MAIN_NODE);
			xmlNode.AddAttribute ( new bOSdotNET.XML.XMLAttribute (XMLBehaviourFinish.MODE_ATTRIBUTE, sMode) );
			
			xmlNode.AddNode ( new bOSdotNET.XML.XMLNode (XMLBehaviourFinish.REPORT_NODE, sReport) );

			return xmlNode;
		}
	}
}
