using System;
using ScenarioFramework.WorkflowEngine.DataModel;

namespace ScenarioFramework.WorkflowEngine.DataModel.WorkflowProcesses
{
	public class XMLBehaviourStart : bOSdotNET.XML.Data.XMLObject
	{
		public const string MAIN_NODE				= "Start";

		private const string MODE_ATTRIBUTE			= "Mode";
		private const string ONLYONE_ATTRIBUTE		= "OnlyOne";

		private const string REPORT_NODE			= "Report";

		public const string AUTOMATIC_MODE		= "AUTOMATIC";
		public const string MANUAL_MODE			= "MANUAL";

		public const string YES_ONLYONE			= "YES";
		public const string NO_ONLYONE			= "NO";

		private string sOnlyOne;
		private string sMode;
		private string sReport;

		/** CONSTRUCTORS **/

		/** CONSTRUCTOR Width simple Property **/
		public XMLBehaviourStart()
		{
			this.Init();
		}

		/** CONSTRUCTOR Width xml parsering**/
		public XMLBehaviourStart(System.Xml.XmlNode node)
		{
			this.Parse(node);
		}

		/** PROPERTIES **/


		public string OnlyOne 
		{
			get { return sOnlyOne; }
			set { sOnlyOne = value; }
		}

		public string Mode 
		{
			get { return sMode; }
			set { sMode = value; }
		}

		public string Report 
		{
			get { return sReport; }
			set { sReport = value; }
		}

		/** INSTANCE METHODS **/

		override public void Init()
		{
			sOnlyOne = string.Empty;
			sMode = string.Empty;
			sReport = string.Empty;
		}

		override public void Parse(System.Xml.XmlNode node2Parse)
		{
			this.Init();

			System.Xml.XmlNode node;

			
			/** find the attributes situated on the root tag **/
			for ( int i=0; i<node2Parse.Attributes.Count;i++)
			{
				node = node2Parse.Attributes.Item(i);

				switch ( node.Name )
				{
					case XMLBehaviourStart.MODE_ATTRIBUTE:
						sMode = node.InnerText;
						break;
					case XMLBehaviourStart.ONLYONE_ATTRIBUTE:
						sOnlyOne = node.InnerText;
						break;
				}
			}

			/** find the sub tags witch contains values **/
			for ( int i=0; i<node2Parse.ChildNodes.Count; i++)
			{
				node = node2Parse.ChildNodes[i];

				switch ( node.Name )
				{
					case XMLBehaviourStart.REPORT_NODE:
						sReport= node.InnerText;
						break;
				}
			}
		}

		override public bOSdotNET.XML.XMLNode GetXMLNode()
		{
			bOSdotNET.XML.XMLNode xmlNode = new bOSdotNET.XML.XMLNode(XMLBehaviourStart.MAIN_NODE);
			xmlNode.AddAttribute ( new bOSdotNET.XML.XMLAttribute (XMLBehaviourStart.MODE_ATTRIBUTE, sMode) );
			xmlNode.AddAttribute ( new bOSdotNET.XML.XMLAttribute (XMLBehaviourStart.ONLYONE_ATTRIBUTE, sOnlyOne) );
			
			xmlNode.AddNode ( new bOSdotNET.XML.XMLNode (XMLBehaviourStart.REPORT_NODE, sReport) );

			return xmlNode;
		}
	}
}
