using System;
using ScenarioFramework.WorkflowEngine.DataModel;

namespace ScenarioFramework.WorkflowEngine.DataModel.WorkflowProcesses
{
	//*********************************************************************
	//
	// XmlTransitions Class
	//
	// The XmlTransitions class represents a collection base of XmlTransition
	// Its imports methods from WAPI.XmlObjectSet like get set and add
	// XmlTransitions Has no fields
	//
	//*********************************************************************

	public class XMLTransitions : bOSdotNET.XML.Data.XMLObjectSet 
	{
		public const string MAIN_NODE	= "Transitions";

		/** FIELDS **/

		/** no fields **/

		/** CONSTRUCTORS **/

		/** CONSTRUCTOR Empty **/
		public XMLTransitions()
		{
			this.Init();
		}

		/** CONSTRUCTOR Width xml parsering**/
		public XMLTransitions(System.Xml.XmlNode nodeList)
		{
			this.Parse (nodeList);
		}

		/** INSTANCE METHODS **/

		public override void Init()
		{
			this.RemoveAll();
		}

		public override void Parse(System.Xml.XmlNode nodeList)
		{
			this.Init();

			System.Xml.XmlNode node;

			for ( int i=0; i<nodeList.ChildNodes.Count;i++)
			{
				node = nodeList.ChildNodes[i];

				switch ( node.Name) 
				{
					case XMLTransition.MAIN_NODE:
						this.Add ( new XMLTransition(node));
						break;
				}
			}
		}

		override public bOSdotNET.XML.XMLNode GetXMLNode()
		{
			bOSdotNET.XML.XMLNode xmlNode = new bOSdotNET.XML.XMLNode(XMLTransitions.MAIN_NODE);

			for ( int i=0; i<this.Count;i++)
			{
				xmlNode.AddNode ( this[i].GetXMLNode() );

			}

			return xmlNode;
		}

		/** Instance methods to check if a WF is in collection **/

		/** TODO 
		
		**/

		/** WAPI Wrappers to call SCENARIO ENGINE **/

		/** TODO 
		
		**/
	}
}