using System;
using ScenarioFramework.WorkflowEngine.DataModel;

namespace ScenarioFramework.WorkflowEngine.DataModel.WorkflowServices
{
	//*********************************************************************
	//
	// Service Class
	//
	// toto : inserire l'esatta descrizione di ci che fa l'oggetto
	//
	//*********************************************************************
	public class XMLService : bOSdotNET.XML.Data.XMLObject 
	{
		public const string MAIN_NODE				= "Service";

		private const string NAME_ATTRIBUTE		= "Name";
		private const string WORKFLOW_NODE		= "Workflow";
		private const string DESCRIPTION_NODE	= "Description";

		/** FIELDS **/

		private String sName;
		private String sWorkflow;
		private String sDescription;

		private WorkflowParticipantsData.XMLRoles vRoles;
		private WorkflowParticipantsData.XMLUsers vUsers;
		private Common.XMLExtendedAttributes vExtendedAttributes;

		/** CONSTRUCTORS **/

		/** CONSTRUCTOR Width simple Property **/
		public XMLService()
		{
			this.Init();
		}

		/** CONSTRUCTOR Width xml parsering**/
		public XMLService(System.Xml.XmlNode node)
		{
			this.Parse(node);
		}

		/** PROPERTIES **/
		public WorkflowParticipantsData.XMLRoles XMLRoles
		{
			get { return vRoles; }
			set { vRoles = value; }
		}

		public WorkflowParticipantsData.XMLUsers XMLUsers
		{
			get { return vUsers; }
			set { vUsers = value; }
		}

		public Common.XMLExtendedAttributes XMLExtendedAttributes
		{
			get { return vExtendedAttributes; }
			set { vExtendedAttributes = value; }
		}

		public string Name 
		{
			get { return sName; }
			set { sName = value; }
		}

		public string Workflow 
		{
			get { return sWorkflow; }
			set { sWorkflow = value; }
		}

		public string Description 
		{
			get { return sDescription; }
			set { sDescription = value; }
		}

		/** INSTANCE METHODS **/

		override public void Init()
		{
			sName= string.Empty;
			sWorkflow= string.Empty;
			sDescription= string.Empty;

			vRoles = new WorkflowParticipantsData.XMLRoles();
			vUsers = new WorkflowParticipantsData.XMLUsers();
			vExtendedAttributes = new Common.XMLExtendedAttributes();
		}

		/** Parsering method to fill the object **/
		override public void Parse(System.Xml.XmlNode node2Parse)
		{
			this.Init();

			System.Xml.XmlNode node;

			/** find the attributes situated on the root tag **/
			for ( int i=0; i<node2Parse.Attributes.Count;i++)
			{
				node = node2Parse.Attributes.Item(i);
				switch ( node.Name ) 
				{
					case XMLService.NAME_ATTRIBUTE:
						sName = node.InnerText;
						break;
				}
			}

			/** find the attributes situated on sub tags **/
			for ( int i=0; i<node2Parse.ChildNodes.Count; i++)
			{
				node = node2Parse.ChildNodes[i];

				switch ( node.Name)
				{
					case XMLService.WORKFLOW_NODE:
						sWorkflow=node.InnerText;
						break;

					case XMLService.DESCRIPTION_NODE:
						sDescription=node.InnerText;
						break;

					case WorkflowParticipantsData.XMLRoles.MAIN_NODE:
						vRoles.Parse (node);
						break;

					case WorkflowParticipantsData.XMLUsers.MAIN_NODE:
						vUsers.Parse(node);
						break;

					case Common.XMLExtendedAttributes.MAIN_NODE:
						vExtendedAttributes.Parse (node);
						break;
				}
			}
		}

		/**Method to retive a node from object **/
		override public bOSdotNET.XML.XMLNode GetXMLNode()
		{
			bOSdotNET.XML.XMLNode xmlNode = new bOSdotNET.XML.XMLNode(XMLService.MAIN_NODE);
			xmlNode.AddAttribute ( new bOSdotNET.XML.XMLAttribute (XMLService.NAME_ATTRIBUTE, sName) );
			xmlNode.AddNode ( new bOSdotNET.XML.XMLNode (XMLService.WORKFLOW_NODE, sWorkflow) );
			xmlNode.AddNode ( new bOSdotNET.XML.XMLNode (XMLService.DESCRIPTION_NODE,sDescription) );

			xmlNode.AddNode ( vRoles.GetXMLNode() );
			xmlNode.AddNode ( vUsers.GetXMLNode() );
			xmlNode.AddNode ( vExtendedAttributes.GetXMLNode() );

			return xmlNode;
		}
	}
}
