﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ScenarioFramework.AddIns.HostView;
using System.AddIn.Pipeline;
using ScenarioFramework.AddIns.Contracts;

namespace ScenarioFramework.Addins.HostAdapter
{
    /// <summary>
    /// This class converts a contract instance to the host view
    /// </summary>
    [HostAdapter]
    public class SimpleContractToHostViewAdapter : SimpleAddInHostView
    {
        private ISimpleContract _contract;
        private ContractHandle _handle;

        public SimpleContractToHostViewAdapter(ISimpleContract contract)
        {
            this._contract = contract;
            _handle = new ContractHandle(contract);
        }

        public override string SayHello(string name)
        {
            return this._contract.SayHello(name);
        }
    }
}
