using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using WorkflowProcesses = ScenarioFramework.WorkflowEngine.DataModel.WorkflowProcesses;
using WorkflowRelevantData = ScenarioFramework.WorkflowEngine.DataModel.WorkflowRelevantData;

using WAPI = ScenarioFramework.WAPI;

namespace Scenario.Modeler
{
	/// <summary>
	/// Summary description for FormStartProcess.
	/// </summary>
	public class FormStartProcess : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnOk;
        private System.Windows.Forms.Label lblProcess;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtProcessID;
		private System.Windows.Forms.Button btnCreateProcess;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
        private ScenarioFramework.Tools.UI.Controls.ListControls.ProcessTemplateComboBox ddlProcessTemplate;
        private ScenarioFramework.Tools.UI.Controls.ListControls.AttributeList listAttributes;


		private WorkflowProcesses.XMLWorkflow xmlWorkflow = null;

		public FormStartProcess()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.panel2 = new System.Windows.Forms.Panel();
            this.btnCancel = new System.Windows.Forms.Button();
            this.btnOk = new System.Windows.Forms.Button();
            this.lblProcess = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.txtProcessID = new System.Windows.Forms.TextBox();
            this.btnCreateProcess = new System.Windows.Forms.Button();
            this.ddlProcessTemplate = new ScenarioFramework.Tools.UI.Controls.ListControls.ProcessTemplateComboBox();
            this.listAttributes = new ScenarioFramework.Tools.UI.Controls.ListControls.AttributeList();
            this.panel2.SuspendLayout();
            this.SuspendLayout();
            // 
            // panel2
            // 
            this.panel2.Controls.Add(this.btnCancel);
            this.panel2.Controls.Add(this.btnOk);
            this.panel2.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panel2.Location = new System.Drawing.Point(0, 385);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(445, 41);
            this.panel2.TabIndex = 16;
            // 
            // btnCancel
            // 
            this.btnCancel.Location = new System.Drawing.Point(227, 7);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(60, 35);
            this.btnCancel.TabIndex = 10;
            this.btnCancel.Text = "Cancel";
            this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
            // 
            // btnOk
            // 
            this.btnOk.Enabled = false;
            this.btnOk.Location = new System.Drawing.Point(141, 6);
            this.btnOk.Name = "btnOk";
            this.btnOk.Size = new System.Drawing.Size(67, 35);
            this.btnOk.TabIndex = 9;
            this.btnOk.Text = "Start";
            this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
            // 
            // lblProcess
            // 
            this.lblProcess.Location = new System.Drawing.Point(7, 14);
            this.lblProcess.Name = "lblProcess";
            this.lblProcess.Size = new System.Drawing.Size(386, 14);
            this.lblProcess.TabIndex = 17;
            this.lblProcess.Text = "Process to Start";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(7, 62);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(133, 14);
            this.label1.TabIndex = 20;
            this.label1.Text = "Process ID";
            // 
            // txtProcessID
            // 
            this.txtProcessID.Enabled = false;
            this.txtProcessID.Location = new System.Drawing.Point(10, 78);
            this.txtProcessID.Name = "txtProcessID";
            this.txtProcessID.Size = new System.Drawing.Size(60, 20);
            this.txtProcessID.TabIndex = 21;
            // 
            // btnCreateProcess
            // 
            this.btnCreateProcess.Location = new System.Drawing.Point(329, 62);
            this.btnCreateProcess.Name = "btnCreateProcess";
            this.btnCreateProcess.Size = new System.Drawing.Size(108, 37);
            this.btnCreateProcess.TabIndex = 22;
            this.btnCreateProcess.Text = "Create Process ID";
            this.btnCreateProcess.Click += new System.EventHandler(this.btnCreateProcess_Click);
            // 
            // ddlProcessTemplate
            // 
            this.ddlProcessTemplate.Location = new System.Drawing.Point(10, 32);
            this.ddlProcessTemplate.Name = "ddlProcessTemplate";
            this.ddlProcessTemplate.Size = new System.Drawing.Size(427, 21);
            this.ddlProcessTemplate.TabIndex = 23;
            // 
            // listAttributes
            // 
            this.listAttributes.Location = new System.Drawing.Point(10, 104);
            this.listAttributes.Name = "listAttributes";
            this.listAttributes.Size = new System.Drawing.Size(427, 275);
            this.listAttributes.TabIndex = 24;
            this.listAttributes.UseCompatibleStateImageBehavior = false;
            this.listAttributes.View = System.Windows.Forms.View.Details;
            this.listAttributes.DoubleClick += new System.EventHandler(this.listAttributes_DoubleClick);
            // 
            // FormStartProcess
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(445, 426);
            this.Controls.Add(this.listAttributes);
            this.Controls.Add(this.ddlProcessTemplate);
            this.Controls.Add(this.btnCreateProcess);
            this.Controls.Add(this.txtProcessID);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.lblProcess);
            this.Controls.Add(this.panel2);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
            this.Name = "FormStartProcess";
            this.Text = "Start Process";
            this.panel2.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btnOk_Click(object sender, System.EventArgs e)
		{
			long lProcessID = Int32.Parse(this.txtProcessID.Text);
			try
			{
                WAPI.Process.StartInstance(lProcessID, this.listAttributes.XMLAttributes);
			}
			catch (WAPI.Exception.WAPIException err )
			{
				MessageBox.Show ("Impossible to start Process[" + lProcessID + "]. Error:[" + err.Message + "]");
				return;
			}

			MessageBox.Show ("Process Started correctly. ID[" + lProcessID + "]");
			this.Close();
		}

		private void ddlProcessTemplate_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			this.txtProcessID.Text = string.Empty;
			this.btnOk.Enabled = false;
			this.listAttributes.Enabled = false;
		}

		private void btnCreateProcess_Click(object sender, System.EventArgs e)
		{
			if ( this.ddlProcessTemplate.SelectedIndex<0 ) 
			{
				MessageBox.Show ("A Process selection is mandatory");
				return;
			}

			this.listAttributes.Items.Clear();

            this.xmlWorkflow = WAPI.Process.CreateInstance(this.ddlProcessTemplate.WorkflowName);
            this.txtProcessID.Text = this.xmlWorkflow.ProcessId.ToString();

            this.listAttributes.LoadProcessAttributes(this.xmlWorkflow.ProcessId);

			this.btnOk.Enabled = true;

		}

		private void listAttributes_DoubleClick(object sender, System.EventArgs e)
		{
			if ( listAttributes.SelectedItems.Count == 0 )
			{
				return;
			}

			WorkflowRelevantData.XMLAttribute xmlAttribute = this.listAttributes.AttributeSelected;
			/*xmlAttribute.Name = listAttributes.SelectedItems[0].SubItems[0].Text;
			xmlAttribute.Value = listAttributes.SelectedItems[0].SubItems[1].Text;
			xmlAttribute.Type = "";
			xmlAttribute.Direction = WorkflowRelevantData.XMLAttribute.DIRECTION_NONE;*/

			FormAttribute form = new FormAttribute(xmlAttribute);
			form.ShowDialog (this);

			if ( form.xmlAttribute != null )
			{
                this.listAttributes.AttributeSelected = form.xmlAttribute;
			}
		}

	}
}
